/*
---

name: Meio.Mask

description: The base component for the Meio.Mask plugin.

authors:
  - Fábio Miranda Costa

requires:
  - Core/Class.Extras
  - Core/Element.Event
  - Core/Element.Style
  - More/Element.Forms

license: MIT-style license

provides: [Meio.Mask]

...
*/
(function(B,C){var A=B.Meio||{};Object.append(Element.NativeEvents,{"paste":2,"input":2});Element.Events.paste={base:(Browser.opera||(Browser.firefox&&Browser.version<3))?"input":"paste",condition:function(D){this.fireEvent("paste",D,1);return false}};A.Mask=new Class({Implements:[Options,Events],options:{selectOnFocus:true,autoTab:false},initialize:function(D){this.setOptions(D);this.ignore=false;this.bound={"focus":0,"blur":0,"keydown":0,"keypress":0,"paste":0}},link:function(D){D=C(D);if(D.get("tag")!="input"||D.get("type")!="text"){return }if(this.element){this.unlink()}this.element=D;return this.attach()},unlink:function(){return this.detach()},attach:function(){var E=this;if(this.maxlength==null){this.maxlength=this.element.get("maxLength")}this.element.removeAttribute("maxLength");for(var D in this.bound){this.bound[D]=(function(H,G){return function(I){return H.call(E,I,G)}})(this.onMask,this[D]);this.element.addEvent(D,this.bound[D])}var F=this.element.get("value");if(F!=""){this.element.set("value",this.mask(F))}return this},detach:function(){var E=this.maxlength;if(E!=null){this.element.set("maxlength",E)}for(var D in this.bound){this.element.removeEvent(D,this.bound[D]);this.bound[D]=0}this.element=null;return this},dettach:function(){this.detach()},onMask:function(G,E){if(this.element.get("readonly")){return true}var H={},D=G.event,F=(G.type=="paste")?null:D.keyCode;H.range=this.element.getSelectedRange();H.isSelection=(H.range.start!==H.range.end);H.isDelKey=(F==46&&(D.type!="keypress"||((Browser.firefox||Browser.opera)&&!D.which)));H.isBksKey=(F==8||(Browser.Platform.ios&&G.code==127));H.isRemoveKey=(H.isBksKey||H.isDelKey);E&&E.call(this,G,H);return true},keydown:function(E,F){this.ignore=(A.Mask.ignoreKeys[E.code]&&!F.isRemoveKey)||E.control||E.meta||E.alt;if(this.ignore||F.isRemoveKey){var D=A.Mask.ignoreKeys[E.code]||"";this.fireEvent("valid",[this.element,E.code,D])}return(Browser.Platform.ios||(A.Mask.onlyKeyDownRepeat&&F.isRemoveKey))?this.keypress(E,F):true},keypress:function(E,F){if(this.options.autoTab&&this.shouldFocusNext()){var D=this.getNextInput();if(D){D.focus();if(D.select){D.select()}}}return true},focus:function(E,F){var D=this.element;D.store("meiomask:focusvalue",D.get("value"))},blur:function(E,F){var D=this.element;if(E&&D.retrieve("meiomask:focusvalue")!=D.get("value")){D.fireEvent("change")}},getCurrentState:function(G,H){var E=String.fromCharCode(G.code),F=this.element.get("value");var I=H.range.start,D=H.range.end;if(H.isRemoveKey&&!H.isSelection){H.isDelKey?D++:I--}return{value:F.substring(0,I)+(H.isRemoveKey?"":E)+F.substring(D),_char:E,start:I,end:D}},setSize:function(){if(!this.element.get("size")){this.element.set("size",this.maskArray.length)}},shouldFocusNext:function(){var D=this.options.maxLength;return D&&this.element.get("value").length>=D},getNextInput:function(){var D=Array.from(this.element.form.elements),G;for(var F=D.indexOf(this.element)+1,E=D.length;F<E;F++){G=D[F];if(this.isFocusableField(G)){return C(G)}}return null},isFocusableField:function(D){return(D.offsetWidth>0||D.offsetHeight>0)&&D.nodeName.toLowerCase()!="fieldset"},isFixedChar:function(D){return !A.Mask.matchRules.contains(D)},mask:function(D){return D},unmask:function(D){return D}});A.Mask.extend({matchRules:"",rulesRegex:new RegExp(""),rules:{},setRule:function(D,E){this.setRules({ruleKey:E})},setRules:function(D){Object.append(this.rules,D);var E=[];for(rule in D){E.push(rule)}this.matchRules+=E.join("");this.recompileRulesRegex()},removeRule:function(D){delete this.rules[D];this.matchRules=this.matchRules.replace(D,"");this.recompileRulesRegex()},removeRules:function(){var D=Array.flatten(arguments);for(var E=D.length;E--;){this.removeRule(D[E])}},recompileRulesRegex:function(){this.rulesRegex.compile("["+this.matchRules.escapeRegExp()+"]","g")},createMasks:function(E,D){E=E.capitalize();for(mask in D){this[E][mask.camelCase().capitalize()]=new Class({Extends:this[E],options:D[mask]})}},upTo:function(D){D=""+D;return function(G,F,E){if(G.charAt(F-1)==D[0]){return(E<=D[1])}return true}},onlyKeyDownRepeat:!!(Browser.ie||Browser.chrome||(Browser.safari&&Browser.version>=4))}).extend(function(){var E;var G={8:"backspace",9:"tab",13:"enter",16:"shift",17:"control",18:"alt",27:"esc",33:"page up",34:"page down",35:"end",36:"home",37:"left",38:"up",39:"right",40:"down",45:"insert",46:"delete",224:"command"},F={10:"go",127:"delete"};if(Browser.Platform.ios){E=F}else{for(var D=1;D<=12;D++){G[111+D]="f"+D}E=G}return{ignoreKeys:E}}()).setRules((function(){var E={"z":{regex:/[a-z]/},"Z":{regex:/[A-Z]/},"a":{regex:/[a-zA-Z]/},"*":{regex:/[0-9a-zA-Z]/},"@":{regex:/[0-9a-zA-ZçáàãâéèêíìóòõôúùüñÇÁÀÃÂÉÈÊÍÌÓÒÕÔÚÙÜÑ]/},"h":{regex:/[0-9]/,check:A.Mask.upTo(23)},"d":{regex:/[0-9]/,check:A.Mask.upTo(31)},"m":{regex:/[0-9]/,check:A.Mask.upTo(12)}};for(var D=0;D<=9;D++){E[D]={regex:new RegExp("[0-"+D+"]")}}return E})());B.Meio=A})(this,document.id);Meio.Mask.Fixed=new Class({Extends:Meio.Mask,options:{autoSetSize:false,placeholder:"_",removeIfInvalid:false,removeInvalidTrailingChars:true},initialize:function(A){this.parent(A);this.slice=Array.prototype.slice;this.maskArray=this.options.mask.split("");this.maskMold=this.options.mask.replace(Meio.Mask.rulesRegex,this.options.placeholder).split("");this.maskMoldEmpty=this.slice.call(this.maskMold);this.validIndexes=[];this.maskArray.each(function(C,B){if(!this.isFixedChar(C)){this.validIndexes.push(B)}},this);this.createUnmaskRegex()},link:function(B){this.parent(B);var D=this.element.get("value");if(D!=""){var C=this.mask(D);for(var A=C.length;A--;){this.maskMold[A]=C.charAt(A)}}if(this.options.autoSetSize){this.setSize()}return this},focus:function(A,B){this.element.set("value",this.maskMold.join(""));if(this.options.selectOnFocus&&this.element.select){this.element.select()}this.parent(A,B)},blur:function(A,C){this.parent(A,C);var B=this.element.get("value");if(this.options.removeIfInvalid){if(B.contains(this.options.placeholder)){this.maskMold=this.split.call(this.maskMoldEmpty);this.element.set("value","")}return true}if(this.options.removeInvalidTrailingChars){this.element.set("value",this.removeInvalidTrailingChars(B))}return true},keypress:function(J,D){if(this.ignore){return true}J.preventDefault();var K=String.fromCharCode(J.code),E=this.maskArray,C,G,B;if(!D.isSelection){var H;if(D.isBksKey){do{C=this.validIndexes.indexOf(--D.range.start)}while(C==-1&&D.range.start>=0);H=this.validIndexes[C]||0}else{do{C=this.validIndexes.indexOf(D.range.start++)}while(C==-1&&D.range.start<E.length);H=(C==-1)?this.maskMold.length:this.validIndexes[C+1]}G=this.validIndexes[C];if(!(B=this.testEvents(G,K,J.code,D.isRemoveKey))){return true}if(typeof B=="string"){K=B}this.maskMold[G]=(D.isRemoveKey)?this.options.placeholder:K;var L=(H==null)?this.maskMold.length:H;this.element.set("value",this.maskMold.join("")).setCaretPosition(L)}else{var A=D.range.start,I=D.range.end,F;do{C=this.validIndexes.indexOf(D.range.start++)}while(C==-1&&D.range.start<E.length);do{F=this.validIndexes.indexOf(D.range.end++)}while(F==-1&&D.range.end<E.length);if(!(F-C)){return true}for(G=A;G<I;G++){this.maskMold[G]=this.maskMoldEmpty[G]}if(!D.isRemoveKey){G=this.validIndexes[C];if(!(B=this.testEvents(G,K,J.code,D.isRemoveKey))){return true}if(typeof B=="string"){K=B}this.maskMold[G]=K;C++}this.element.set("value",this.maskMold.join(""));this.element.setCaretPosition(this.validIndexes[C])}return this.parent()},paste:function(B,C){var A=this.applyMask(this.element.get("value"),C.range.start);this.maskMold=A.value;this.element.set("value",this.maskMold.join("")).setCaretPosition(A.rangeStart);return true},removeInvalidTrailingChars:function(E){var B=E.length,D=this.options.placeholder,C=E.length-1,A;while(C>=0){A=false;while(this.isFixedChar(E.charAt(C))&&E.charAt(C)!==D){if(C==0){B=0}A=true;C--}while(E.charAt(C)===D){B=C;A=true;C--}if(!A){break}}return E.substring(0,B)},testEvents:function(D,A,E,G){var C=this.maskArray,F=Meio.Mask.rules[C[D]],H;if(!G){var B=[this.element,E,A];if(!F||!(H=this.testEntry(this.element.get("value"),D,A))){this.fireEvent("invalid",B);return false}this.fireEvent("valid",B)}return(H!=null)?H:true},shouldFocusNext:function(){return this.unmask(this.element.get("value")).length>=this.validIndexes.length},createUnmaskRegex:function(){var A=[].combine(this.options.mask.replace(Meio.Mask.rulesRegex,"").split(""));var B=(A.join("")+this.options.placeholder).escapeRegExp();this.unmaskRegex=B?new RegExp("["+B+"]","g"):null},testEntry:function(F,D,A){var C=this.maskArray,E=Meio.Mask.rules[C[D]],B=(E&&E.regex.test(A));return(E.check&&B)?E.check(F,D,A):B},applyMask:function(H,D){var A=H.split(""),C=this.maskArray,E=this.maskMold,G=Meio.Mask.rules,B=0,F;while(B<E.length){if(!A[B]){A[B]=E[B]}else{if(G[C[B]]){if(!(F=this.testEntry(H,B,A[B]))){A.splice(B,1);continue}else{if(typeof F=="string"){A[B]=F}}newStartRange=B}else{if(C[B]!=A[B]){A.splice(B,0,E[B])}else{A[B]=E[B]}}}B++}return{value:A.slice(0,this.maskMoldEmpty.length),rangeStart:D+1}},mask:function(A){A=this.applyMask(A).value.join("");if(this.options.removeInvalidTrailingChars){A=this.removeInvalidTrailingChars(A)}return A},unmask:function(A){return this.unmaskRegex?A.replace(this.unmaskRegex,""):A}});Meio.Mask.createMasks("Fixed",{"Phone":{mask:"(99) 9999-9999"},"PhoneUs":{mask:"(999) 999-9999"},"Cpf":{mask:"999.999.999-99"},"Cnpj":{mask:"99.999.999/9999-99"},"Date":{mask:"3d/1m/9999"},"DateUs":{mask:"1m/3d/9999"},"Cep":{mask:"99999-999"},"Time":{mask:"2h:59"},"Cc":{mask:"9999 9999 9999 9999"}});Meio.Mask.Reverse=new Class({Extends:Meio.Mask,options:{autoSetSize:false,autoEmpty:false,alignText:true,symbol:"",precision:2,decimal:",",thousands:".",maxLength:18},initialize:function(A){this.parent(A);var C=this.options.thousands,D=C.escapeRegExp(),B=this.options.decimal.escapeRegExp();this.maxlength=this.options.maxLength;this.reThousands=/(\d+)(\d{3})/;this.reRemoveLeadingZeros=/^0+(.*)$/;this.reDecimalNumber=/^\d$/;this.thousandsReplaceStr="$1"+C+"$2";this.reThousandsReplace=new RegExp(D,"g");this.reCleanup=new RegExp("["+D+B+"]","g");this.reRemoveNonNumbers=new RegExp("[^\\d"+D+B+"]","g")},link:function(A){this.parent(A);if(this.options.alignText){this.element.setStyle("text-align","right")}var B=this.element.get("value");if(B===""&&!this.options.autoEmpty){this.element.set("value",this.forceMask(B,false))}return this},focus:function(C,D){var A=this.element,B=A.get("value");if(this.options.autoEmpty){if(B===""){A.set("value",(B=this.mask(B)))}}else{A.set("value",(B=this.getValue(B,true)))}if(this.options.selectOnFocus){A.selectRange(this.options.symbol.length,B.length)}this.parent(C,D)},blur:function(C,D){this.parent(C,D);var A=this.element,B=this.getValue(A.get("value"));if(this.options.autoEmpty&&this.mask(B)==this.mask()){B=""}A.set("value",B)},keypress:function(B,D){if(this.ignore){return true}B.preventDefault();var A=this.getCurrentState(B,D),C=A.value;if(!this.testEvents(C,A._char,B.code,D.isRemoveKey)){return true}C=this.forceMask(C,true);this.element.set("value",C).setCaretPosition(C.length);return this.parent()},testEvents:function(F,A,C,E){var B=[this.element,C,A];if(!E){var D=this.getValue(F,false).length;if(!(this.reDecimalNumber).test(A)||(this.maxlength&&D>this.maxlength)){this.fireEvent("invalid",B);return false}this.fireEvent("valid",B)}return true},paste:function(B,C){var A=this.element;elValue=A.get("value");A.set("value",(elValue=this.forceMask(elValue,true))).setCaretPosition(elValue.length);return true},forceMask:function(E,D){E=this.cleanup(E);var A=this.options.precision;var B=A+1-E.length;if(B>0){E=this.zeroize(E,B)}if(A){var C=E.length-A;E=E.substring(0,C)+this.options.decimal+E.substring(C)}return this.getValue(this.maskThousands(E),D)},cleanup:function(A){return this.getValue(A.replace(this.reCleanup,"")).replace(this.reRemoveLeadingZeros,"$1")},mask:function(A){A=this.unmask(A||"0").replace(".",this.options.decimal);return this.getValue(this.maskThousands(A),false)},unmask:function(A){return this.toNumber(this.getValue(A))},toNumber:function(B){B=B.replace(this.reRemoveNonNumbers,"");if(!isFinite(B)){if(this.options.thousands){B=B.replace(this.reThousandsReplace,"")}var A=this.options.decimal;if(A){B=B.replace(A,".")}}return B.toFloat().toFixed(this.options.precision)},getValue:function(C,B){var A=this.options.symbol;return(C.substring(0,A.length)===A)?B?C:C.substring(A.length):B?A+C:C},maskThousands:function(A){if(this.options.thousands){while(this.reThousands.test(A)){A=A.replace(this.reThousands,this.thousandsReplaceStr)}}return A},zeroize:function(B,A){while(A--){B="0"+B}return B},shouldFocusNext:function(){return this.getValue(this.element.get("value"),false).length>=this.options.maxLength}});Meio.Mask.createMasks("Reverse",{"Integer":{precision:0,maxLength:18},"Decimal":{},"DecimalUs":{thousands:",",decimal:"."},"Reais":{symbol:"R$ "},"Dollar":{symbol:"US$ ",thousands:",",decimal:"."}});Meio.Mask.Repeat=new Class({Extends:Meio.Mask,options:{mask:"",maxLength:0},keypress:function(D,F){if(this.ignore){return true}D.preventDefault();var C=this.getCurrentState(D,F);var E=Meio.Mask.rules[this.options.mask.charAt(0)].regex;var B=[this.element,C._char,D.code];var A=this.options.maxLength;if((A&&C.value.length>A)||(!E.test(C._char)&&!F.isRemoveKey)){this.fireEvent("invalid",B)}else{this.fireEvent("valid",B);this.element.set("value",C.value).setCaretPosition(C.start+(F.isRemoveKey?0:1))}return this.parent()},paste:function(B,C){var A=this.mask(this.element.get("value"));this.element.set("value",A).setCaretPosition(A.length)},mask:function(E){var B=E.split(""),D=Meio.Mask.rules[this.options.mask.charAt(0)].regex;for(var C=0;C<B.length;C++){if(!D.test(B[C])){B.splice(C,1);C--}}var A=this.options.maxLength;return B.join("").substring(0,A?A:B.length)}});Meio.Mask.Regexp=new Class({Extends:Meio.Mask,options:{regex:null},initialize:function(B,A){this.parent(B,A);this.regex=new RegExp(this.options.regex)},keypress:function(C,D){if(this.ignore){return true}C.preventDefault();var B=this.getCurrentState(C,D);var A=[this.element,B._char,C.code];if(!this.regex.test(B.value)){this.fireEvent("invalid",A)}else{this.element.set("value",B.value).setCaretPosition(B.start+(D.isRemoveKey?0:1));this.fireEvent("valid",A)}return true},paste:function(B,C){var A=this.applyMask(this.element.get("value"),true);this.element.set("value",A.value).setCaretPosition(A.index)},applyMask:function(E,C){var A="",D;for(var B=1;B<=E.length;B++){D=E.substring(0,B);if(!this.regex.test(D)){if(C){this.fireEvent("invalid",[this.element,E.charAt(B),E.charCodeAt(B)])}break}A=D}return{value:A,index:B}},mask:function(A){return this.applyMask(A).value}});Meio.Mask.createMasks("Regexp",{"Ip":{regex:/^(\d{0,3}\.){0,3}(\d{0,3})?$/},"Email":{regex:/^[\w.!#$%&'*+=?~^_`{|}\/-]*@?[.\w-]*$/}});(function(){var C="meiomask";var A=function(E){return E.camelCase().capitalize()};var D=function(G,F,H){var E;if(typeOf(G)=="string"){if(typeOf(F)!="string"){H=F;G=G.split(".");F=G[1];G=G[0]}E=Meio.Mask[A(G)];if(F){E=E[A(F)]}}else{E=G;H=F}return{klass:E,options:H||{}}};var B=function(F,E){var G=D.apply(null,E);return new G.klass(G.options)[F](this)};String.implement({meiomask:function(){return B.call(this,"mask",arguments)},meiounmask:function(){return B.call(this,"unmask",arguments)}});Element.Properties.meiomask={set:function(E){E=D.apply(null,E),mask=this.retrieve(C);if(mask){mask.unlink();mask=null}return this.store(C,new E.klass(E.options).link(this))},get:function(){return this.retrieve(C)},erase:function(){var E=this.retrieve(C);if(E){E.unlink()}return this}};Element.Properties[C+":value"]={set:function(F){var E=this.retrieve(C);if(E){F=E.mask(F)}return this.set("value",F)},get:function(){var E=this.retrieve(C);var F=this.get("value");return(E)?E.unmask(F):F}};Element.implement({meiomask:function(E,G,F){return this.set(C,[E,G,F])}})})()